#!/usr/bin/env python3
# -*- coding: utf-8 -*-
#
# TODO: marche pas/plus

import waves as w
import tbox.gmsh as gmsh

def main():
    msh = gmsh.MeshLoader("geophysique.geo", __file__).execute()
    print(msh)

    pbl = w.Problem(msh)
    pbl.c = 1500.0

    c    = 1500.0
    X    = 250.0;    Y=250.0;    Z=250.0
    freq = 10.0
    lam  = c / freq
    lc   = lam / 10
    N    = Z / lc
    Le   = X/N
    dt   = Le/c/10

    scheme = w.ForwardEuler(pbl)

    import waves.srcs
    waves.srcs.SinSource(msh, 10, 10.0)  # le no 10 ne passe pas!
    w.Medium(msh, 1, c)
    w.Medium(msh, 2, c)
    w.Medium(msh, 3, c)
    w.Medium(msh, 4, c)

    from fwk.wutils import parseargs
    args=parseargs()
    
    scheme.ttot = 1.0
    scheme.dt = dt
    scheme.savefreq = 5
    scheme.nthreads = args.k

    if args.nogui:
        scheme.start()
    else:
        import waves.viewer as v
        gui = v.MeshViewer(scheme)
        gui.vmin = -0.1
        gui.vmax =  0.1
        gui.start()

if __name__ == "__main__":
    main()
